

// Here is defined the structure of the menu.
// The menu consists in an address list, 3 similars class for menu entries, 
// 1 class for a cursor and 1 class for a preset. These class are kind of template
// that will be used to create menu objects quicker (see in the next tab.
// The list allows us to store differents functions for each menu slide. And when we move the cursor,
// 1 function is selected inside the list accordingly. For example if we place the cursor at "HEAT" on 
// The control panel, the selected function will become setChoosen_Temp, and if we click the button, 
// setChoosen_Temp will execute and we'll able to set the desired temperature.

int Liste[15];      //Here we define a List with 15 entries max

// and below is a function that fills the list with functions's adresses
// by default they all point to move the cursor's function.

void setList(int f0 = &incdecCursor1, int f1 = &incdecCursor1, int f2 = &incdecCursor1, int f3 = &incdecCursor1, int f4 = &incdecCursor1, int f5 = &incdecCursor1, int f6 = &incdecCursor1, int f7 = &incdecCursor1, int f8 = &incdecCursor1, int f9 = &incdecCursor1, int f10 = &incdecCursor1, int f11 = &incdecCursor1, int f12 = &incdecCursor1, int f13 = &incdecCursor1, int f14 = &incdecCursor1)                
{
  Liste[0] = f0;
  Liste[1] = f1;
  Liste[2] = f2;
  Liste[3] = f3;
  Liste[4] = f4;
  Liste[5] = f5;
  Liste[6] = f6;
  Liste[7] = f7;
  Liste[8] = f8;
  Liste[9] = f9;
  Liste[10] = f10;
  Liste[11] = f11;
  Liste[12] = f12;
  Liste[13] = f13;
  Liste[14] = f14;
}


    /// Here we declare 1 of the 3 Item classes : the "Item" class
     
    class Item                        // Class's name... Later we will use it to create the object, ex: HeatControl
    {
   
    protected:
     String Titre;                       // here we store object's Title, ex ("HEAT:   C")
     int PlacementTitreX;                // and we give it a position XY on the LCD ex  (1,3)
     int PlacementTitreY;
     int Value;                          // here we store a value for the item, ex 200               
     int PlacementValueX;                // and we store it's position on the LCD
     int PlacementValueY;
     
    
                                         // Here we define how to interact with this kind of object
                                         // that class "Item" have 4 methods : the first one is the constructor and will be used
                                         // to create the object. The 3 other are to interract with that objet
    public:   
                               
   // Item constructor, will create an object according to what we give it
   // we need to provide titre, placementTitreX and so one...
   Item(String aTitre, int aPlacementTitreX, int aPlacementTitreY, int aValue, int aPlacementValueX, int aPlacementValueY); 
   void Show();                                       // First method (will show the object on the LCD
   void SetValue(int);                                // Second method (will change item's value
   void Refresh(int);                                 // Deuxieme méthode pour actualiser seulement la valeur.
    
    };

     
    // Now we define the methods.
    // starting with the constructor.
    Item::Item(String aTitre, int aPlacementTitreX, int aPlacementTitreY, int aValue, int aPlacementValueX, int aPlacementValueY)
    {
      Titre = aTitre;                                // THe constructor will give to each variables of the object created the value
      PlacementTitreX = aPlacementTitreX;            // given to the corresponding variable of the contructor
      PlacementTitreY = aPlacementTitreY;
      Value = aValue;
      PlacementValueX = aPlacementValueX;
      PlacementValueY = aPlacementValueY;
    }
    
     // Then we define the first method :
     
    void Item::Show()                         // that one shows the value stored by "Titre" to the LCD at the righ position 
    {
      lcd.setCursor(PlacementTitreX, PlacementTitreY);
      lcd.print(Titre);
    }


    void Item::Refresh(int aValue)            // That one shows the value
    { 
      Value = aValue;
      lcd.setCursor(PlacementValueX, PlacementValueY);
      lcd.print(Value);
    }
    
  
    void Item::SetValue(int aValue)         // And that one gives to the object's variable "value", it's new value.
    { 
     lcd.setCursor(PlacementValueX, PlacementValueY);
     lcd.print(F("   "));
     lcd.setCursor(PlacementValueX, PlacementValueY);
     lcd.print(Value);
     Value = aValue;
    
     
    }
    

    /// Now we define another class Itemd that allows to store a type Double variable.
     
    class Itemd                        //class name
    {
   
    protected:                         // class own variables
     String Titre;                       
     int PlacementTitreX;
     int PlacementTitreY;
     double Value;                     // here "Value" is now a "double"                 
     int PlacementValueX;
     int PlacementValueY;
     
    public:                            // structure of object's methods starting by constructor
    
   Itemd(String aTitre, int aPlacementTitreX, int aPlacementTitreY, double aValue, int aPlacementValueX, int aPlacementValueY);
   void Show();                                       
   void SetValue(double);
   void Refresh(double);                       // notice that SetValue and Refresh need a double for that object.
    
    };

     
    // And we define object's methods, starting with constructor.
  
    Itemd::Itemd(String aTitre, int aPlacementTitreX, int aPlacementTitreY, double aValue, int aPlacementValueX, int aPlacementValueY)
    {
      Titre = aTitre;                                
      PlacementTitreX = aPlacementTitreX;
      PlacementTitreY = aPlacementTitreY;
      Value = aValue;
      PlacementValueX = aPlacementValueX;
      PlacementValueY = aPlacementValueY;
    }
    
     // Method Show
     
    void Itemd::Show()                        
    {
      lcd.setCursor(PlacementTitreX, PlacementTitreY);
      lcd.print(Titre);
    }

     //Method Refresh
     
    void Itemd::Refresh(double aValue)                      
    { 
      Value = aValue;
      lcd.setCursor(PlacementValueX, PlacementValueY);
      lcd.print(Value);
    }
    
      //Method setValue
      
    void Itemd::SetValue(double aValue)                          
    { 
     lcd.setCursor(PlacementValueX, PlacementValueY);
     lcd.print(F("   "));
     lcd.setCursor(PlacementValueX, PlacementValueY);
     lcd.print(Value);
     Value = aValue;
    
     
    }
    

/// here we define a class wich contains only a text and a position
     
    class ItemTxt                       //name  
    {
   
    protected:                         //own variables
     String Word;                      
     int PlacementX;
     int PlacementY;
     
    public:                            //Methods
    
   ItemTxt(String aWord, int aPlacementX, int aPlacementY); //constructor
   void Show(); 
   void SetTxt(String);                                                                
    
    };

     
    //Methods definition 
    //Constructor :    
    ItemTxt::ItemTxt(String aWord, int aPlacementX, int aPlacementY) 
    {
     Word = aWord;                       
     PlacementX = aPlacementX;
     PlacementY = aPlacementY;
    }
    
     // Method Show :

    void ItemTxt::Show()                       
    {
      lcd.setCursor(PlacementX, PlacementY);
      lcd.print(Word);
    }

     // Method SetTxt (to give a new text value) :
     
    void ItemTxt::SetTxt(String aWord)                       
    {
      Word = aWord;
      lcd.setCursor(PlacementX, PlacementY);
      lcd.print(Word);
    }

      
     // Here we define a different object class : a cursor 
   
    class Cursor                      // we def this class's name
    {
      private:                         // and define it's private attributes.   
      char Symbol;                     // ... a symbol
      int PosX[15];                     // Possible value for position (15 max, as the max number of
      int PosY[15];                     // list entries at the top)
      unsigned int nbPosXY;             // how many positions can have that cursor
      unsigned int PosXY;               // What is it's actual position's number

      public:
      Cursor(char aSymbol);            // the contructor needs only a symbol
      
      void Show();                      // Method to show the cursor
    
      void Init(int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int, int);              
                                          // Method to adjust possible position number's and set a new list of possible position.
                                         
      unsigned int getPosXY();            // Method to give PosXY's Value (to know where the cursor is)
      void resetPosXY();                  // Method that reset PosXY to zero
      unsigned int getnbPosXY();          // Method to know how many positions the cursor can take
      void MoveDown();                    // Method to move the cursor
      void MoveUp();                      // Method to move the cursor
      void setSymbol(char);               // Method to change cursor's symbol
     };

     Cursor::Cursor(char aSymbol)       //constructor recipe (quite simple).
     {
     Symbol = aSymbol;                          //we just set the cursor's symbol
     }
    

    void Cursor::Show()
      {
        lcd.setCursor(PosX[PosXY], PosY[PosXY]);        // Place the cursor at a position stored by PosXY
        lcd.print(Symbol);
      }

         
        //Methods to move the cursor up and down
 
       void Cursor::MoveDown() 
      {                      
        lcd.setCursor(PosX[PosXY], PosY[PosXY]);        // we place the LCD cursor (virtual) where the cursor is shown
        lcd.print(F(" "));                              // we print some empty character at this place
        PosXY++;                                        // we increment PosXY
        if (PosXY >= nbPosXY) PosXY = nbPosXY -1;       // If we have incrementer to much, we got to the last PosXY value
        Show();                                         // We call again Show to print the cursor at it's new location on the LCD
      }

        void Cursor::MoveUp()
      {                      
        lcd.setCursor(PosX[PosXY], PosY[PosXY]);        // same here but backward ...
        lcd.print(F(" "));                                                                           
        if (PosXY > 0) PosXY--;                         //decrementing, but never under 0
        Show();                                        
      }
      

      //that huge following method is to set cursor's table of possibles positions 

    void Cursor::Init(int anbPosXY, int x0 = 0, int y0 = 0, int x1 = 0, int y1 = 0, int x2 = 0, int y2 = 0, int x3 = 0, int y3 = 0, int x4 = 0, int y4 = 0, int x5 = 0, int y5 = 0, int x6 = 0, int y6 = 0, int x7 = 0, int y7 = 0, int x8 = 0, int y8 = 0, int x9 = 0, int y9 = 0, int x10 = 0, int y10 = 0, int x11 = 0, int y11 = 0, int x12 = 0, int y12 = 0, int x13 = 0, int y13 = 0, int x14 = 0, int y14 = 0)                                           
      {
     nbPosXY = anbPosXY;                        // we set the number of possible positions 
     PosXY = 0;                                 // we start with the position 0 (just to start somewhere)
    
     PosX[0] = x0;                              // and we give each X and Y values according to what is given to the function
     PosX[1] = x1;
     PosX[2] = x2;
     PosX[3] = x3;
     PosX[4] = x4;
     PosX[5] = x5;
     PosX[6] = x6;
     PosX[7] = x7;
     PosX[8] = x8;
     PosX[9] = x9;
     PosX[10] = x10;
     PosX[11] = x11;
     PosX[12] = x12;
     PosX[13] = x13;
     PosX[14] = x14;

     PosY[0] = y0;
     PosY[1] = y1;
     PosY[2] = y2;
     PosY[3] = y3;
     PosY[4] = y4;
     PosY[5] = y5;
     PosY[6] = y6;
     PosY[7] = y7;
     PosY[8] = y8;
     PosY[9] = y9;
     PosY[10] = y10;
     PosY[11] = y11;
     PosY[12] = y12;
     PosY[13] = y13;
     PosY[14] = y14;
      }

       // Here is a simple method to get cursor's XY position
      
     unsigned int Cursor::getPosXY()
     {
      return PosXY ;
     }
  
        // and one to set cursor's position to 0
       
     void Cursor::resetPosXY()
     {
      PosXY = 0 ;
     }

        // that one will give you the number of possible positions
      
     unsigned int Cursor::getnbPosXY()
     {
      return nbPosXY;
     }

        // and that one is to change the symbol

     void Cursor::setSymbol(char aSymbol)
     {
      Symbol = aSymbol;
     }


        //That's it for the cursor !! here is now a new class : Preset.

    class Preset 

        {
          private:                              // Each object "Preset" will have all those variables including a preset name
          String Pname = "Preset (empty)";
          unsigned int Pnum = 0;
          unsigned int Ptemp = 0;
          byte Ppwm_push = 0;
          byte Ppwm_pull = 0;
          bool PpushMode = 0;
          unsigned int PDTarget = 0;
          double PPKp = 0;
          double PPKi = 0;
          double PPKd = 0;
          unsigned int EEaddress = 0;

          public:
          Preset(int, int);        // constructor, will give a preset number and an adress number to write inside the eeprom
          void Show(int, int);     // Method to show Preset's name
          void InitState();        // Method to load from eeprom values and give them to the preset
          void LoadState();        // Method to load from preset values and give it to the program variables (ex "storedchoosen_Temp to Choosen_Temp)
          void SaveState();        // Method to save preset values to eeprom  
          void SetPname(String);   // Method to give a preset a name
          String getName();        // Method to get preset's name   
        };


Preset::Preset(int anum, int aEEaddr) //constructor
{
  Pnum = anum;
  EEaddress = aEEaddr;
}

void Preset::Show(int x, int y)
    {
      lcd.setCursor(x, y);
      lcd.print(F("=="));
      lcd.setCursor(x+2, y);
      lcd.print(Pnum);
      lcd.setCursor(x+3, y);
      lcd.print(Pname); 
      lcd.setCursor(18, y);
      lcd.print(F("==")); 
    }

void Preset::SetPname(String aPname)
      {
        Pname = aPname;
      }
         
String Preset::getName()
     {
      return Pname;    
     }

void Preset::InitState()                              //Load values from eeprom to preset (object)
      {
       int address = EEaddress;
       char arrayPname[15];                                         // it is basically starting to read at EEaddress
       Pname = EEPROM.get(address, arrayPname);                     // read the value of arrayPname
       address += sizeof(arrayPname);                               // then we look ahead for how long is the arrayPname value
       Ptemp = EEPROM.get(address, Ptemp);                          // and we got the new address to read the next value...
       address += sizeof(Ptemp);
       Ppwm_push = EEPROM.get(address, Ppwm_push);
       address += sizeof(Ppwm_push);
       Ppwm_pull = EEPROM.get(address, Ppwm_pull);
       address += sizeof(Ppwm_pull);
       PpushMode = EEPROM.get(address, PpushMode);
       address += sizeof(PpushMode);
       PDTarget = EEPROM.get(address, PDTarget);
       address += sizeof(PDTarget);
       PPKp = EEPROM.get(address, PPKp);       
       address += sizeof(PPKp);
       PPKi = EEPROM.get(address, PPKi); 
       address += sizeof(PPKi);
       PPKd = EEPROM.get(address, PPKd);        
      }

void Preset::LoadState()                         // load Preset values to global running program variables
      {
        aPname = Pname;
        choosen_temp = Ptemp;
        pwm_push = Ppwm_push;
        pwm_pull = Ppwm_pull;
        setpwm_push();
        if (pushMode != PpushMode)              // this is to activate or not AutoPush mode according to the preset
          {
            changePushMode();
          }
        DTarget = PDTarget;
        PKp = PPKp;
        PKi = PPKi;
        PKd = PPKd;      
      }

void Preset::SaveState()                        // saving the preset to eeprom
      {
        Pname = aPname;
        Ptemp = choosen_temp;
        Ppwm_push = pwm_push;
        Ppwm_pull = pwm_pull;
        PpushMode = pushMode;
        PDTarget = DTarget;
        PPKp = PKp;
        PPKi = PKi;
        PPKd = PKd;
        char arrayPname[15];
        Pname.toCharArray(arrayPname, Pname.length()+1); // here a conversion of Pname to a char array is needed to write it on eeprom
        int address = EEaddress;
        EEPROM.put(address, arrayPname);                    
        address += sizeof(arrayPname);                  
        EEPROM.put(address, Ptemp);
        address += sizeof(Ptemp);
        EEPROM.put(address, Ppwm_push);
        address += sizeof(Ppwm_push);
        EEPROM.put(address, Ppwm_pull);
        address += sizeof(Ppwm_pull);
        EEPROM.put(address, PpushMode);
        address += sizeof(PpushMode);
        EEPROM.put(address, PDTarget);  
        address += sizeof(PDTarget);
        EEPROM.put(address, PPKp); 
        address += sizeof(PPKp);
        EEPROM.put(address, PPKi);  
        address += sizeof(PPKi);
        EEPROM.put(address, PPKd);                   
      }
